#SingleInstance FORCE
#NoTrayIcon

DetectHiddenText,On

TV1_W = 0.5 ; Ratio(0..1)
LV2_H = 1.0 ; Ratio(0..1)
Tab_H = 20  ; pixcel
GuiW  = 500
GUiH  = 470
KeyName = RButton Up
KeyNameJ = E{^
Menu_Invest0 = I
Menu_Invest1 = Jn

; 萔`
WS_HSCROLL := 0x00100000
WS_VSCROLL := 0x00200000

SB_HORZ:=0x00
SB_VERT:=0x01
SB_CTRL:=0x02
SBS_VERT:=0x01
SB_Types = SB_HORZ|SB_VERT|SB_CTRL

SB_LINEUP        := 0 ; 
SB_LINEDOWN      := 1 ; 
SB_PAGEUP        := 2 ; y[WAbv
SB_PAGEDOWN      := 3 ; y[WAbv
SB_THUMBPOSITION := 4 ; lParam̉ʃ[hɃT̈ʒu
SB_THUMBTRACK    := 5 ; TړT̈ʒu
SB_TOP           := 6 ; [HOME]L[ꂽ
SB_BOTTMOM       := 7 ; [END]L[ꂽ
SB_ENDSCROLL     := 8 ; XN[I


Gosub, Init
return

Init:
	Menu, GMenu, Add, %Menu_Invest1%, MenuInvestEvent
	Gui, +LastFound +Resize +MinSize
	Gui, Menu, GMenu
	Gui, Margin, 0,0 
	Gui, Add, StatusBar, vSB1
	Gui, Add, Tab,       vTb1 ,Invest|Scroll
	Gui, Tab, 1
	Gui, Add, TreeView,  vTV1 gTV1Event AltSubmit
	Gui, Add, ListView,  vLV2 gLV2Event AltSubmit Grid NoSortHdr, name|value
	Gui, Add, ListView,  vLV1 gLV1Event -Multi, Treeid|hwnd|class
	Gui, Tab, 2
	Gui, Add, Text,   x10 y30, hwnd
	GUi, Add, Edit,   vHwnd  x60 y27 w90 readonly, 
	Gui, Add, Text,   x180  y30    , class
	GUi, Add, Edit,   x220 y27 w200 readonly, 
	Gui, Add, Button, x+10 yp+0 , Refresh
	Gui, Add, ListView,  vLV3 gLV3Event AltSubmit disabled r3 grid NoSortHdr -Multi, type|result|min|max|page|pos|trakpos|Vertical
	Gui, Add, Edit,   vSbPos     disabled x10 y+10
	GUi, Add, UpDown, vSbUpDown  disabled 
	Gui, Add, Button, vBtnTPosition disabled x+10 yp+0, ThumPosition
	Gui, Add, Button, vBtnTTrack   disabled x+10 yp+0, ThumTrack
	Gui, Add, Button, vBtnUp disabled x+10 yp+0 gButtonUp  , 
	Gui, Add, Button, vBtnDn disabled x+0  yp+0 gButtonDown, 
	Gui, Font, , MeiryoKe_Console
	GUi, Add, Edit,   vLog x10 y+10 r10 Readonly T10 T30

	Gui, ListView, LV3
	Loop, 5
		LV_ModifyCol(A_Index+2, "Integer")
	Gui, ListView, LV1
	LV_ModifyCol(1,0)

	Menu, M1, Add, XN[eXg, M1_ScrollTest
	Menu, M3, Add, lRs[,       M3_CopyValue

	Gui, Show, w%GuiW% h%GuiH%
	return

GuiSize:
	GuiResize(A_GuiWidth, A_GuiHeight)
	return

GuiResize(guiW, guiH) {
	global TV1_W,LV2_H,Tab_H
	GuiControlGet, sb, POS, SB1
	GuiControl, Move, Tb1, % "x" 0    " y" 0     " w" guiW              " h" (guiH - sbH) 
	GuiControl, Move, TV1, % "x" 0    " y" Tab_H " w" Round(guiW*TV1_W) " h" (guiH - sbH - Tab_H)
	GuiControlGet, pos, POS, TV1
	GuiControl, Move, LV2, % "x" posW " y" Tab_H " w" (guiW - posW)     " h" Round(posH*LV2_H)
	GuiControlGet, pos, POS, LV2
	GuiControl, Move, LV1, % "x" posX " y" posH  " w" posW              " h" (guiH - posH -sbH -Tab_H)
	GuiControl, Move, LV3, % "x" 10   " y" 60     "w" (guiW - 20)
	GuiControl, Move, Log, %                      "w" (guiW - 20)
}

GuiClose:
	ExitApp

GetWindowDetails:
	Hotkey, %A_ThisHotkey%, %A_ThisLabel%, Off
	Menu, GMenu, Rename, %Menu_Invest0%, %Menu_Invest1%
	MouseGetPos(x,y,hwnd,ctrl)
	DoInvest(hwnd, ctrl)
	Gui, Show
	return

MenuInvestEvent:
	if (A_ThisMenuItem = Menu_Invest1) {
		SB_SetText(KeyNameJ "őΏۃEBhE")
		Hotkey, %KeyName%, GetWindowDetails, On
		Menu, %A_ThisMenu%, Rename, %A_ThisMenuItem%, %Menu_Invest0%
	} else {
		SB_SetText("𒆒f܂")
		Hotkey, %KeyName%, GetWindowDetails, Off
		Menu, %A_ThisMenu%, Rename, %A_ThisMenuItem%, %Menu_Invest1%
	}
	return

TV1Event:
	if (A_GuiEvent == "S")
		SelectListViewItemByTreeId(A_EventInfo)
	else if (A_GuiEvent = "RightClick")
		Menu, M1, Show
	return

M1_ScrollTest:
	TreeId := TV_GetSelection()
	Gui, ListView, LV1
	Loop, % LV_GetCount()
	{
		LV_GetText(id,   A_Index, 1)
		LV_GetText(hwnd, A_Index, 2)
		if (id == treeId)
			ScrollTestInit(hwnd)
	}
	return


LV1Event:
	Gui, ListView, LV1
	if (A_GuiEvent == "I" && InStr(ErrorLevel, "S", true))
		SelectTreeViewItemByRowId(A_EventInfo)
	else if (A_GuiEvent = "DoubleClick") {
		ShowControlDetailsByRowId(A_EventInfo)
	}
	return

LV2Event:
	if (A_GuiEvent = "RightClick" && LV_GetNext(0, "F"))
		Menu, M3, Show
	return

LV3Event:
	;Tooltip, [%A_ThisLabel%] %A_GuiEvent% / %A_EventInfo%
	if (A_GuiEvent = "Normal" && A_EventInfo)
		EnableScrollTest(A_EventInfo)
	return

M3_CopyValue:
	LV_GetText(value, LV_GetNext(0, "F"), 2)
	clipboard := value
	return

ButtonRefresh:
	Gui, Submit, NoHide
	ScrollTestInit(hwnd)
	return

ButtonThumPosition:
	DoScrollTest(SB_THUMBPOSITION)
	return

ButtonThumTrack:
	DoScrollTest(SB_THUMBTRACK)
	return

ButtonUp:
	DoScrollTest(SB_LINEUP)
	return

ButtonDown:
	DoScrollTest(SB_LINEDOWN)
	return

DoInvest(hwnd, ctrl) {
	SetFormat, Integer, H
	Gui, TreeView, TV1
	Gui, ListView, LV1
	TV_Delete()
	LV_Delete()
	targetHwnd := hwnd
	rootId := AddItem(hwnd)
	WinGet, list, ControlListHwnd, ahk_id %hwnd%
	Loop, PARSE, list, `n
		AddItem(A_LoopField)
	LV_ModifyCol(1,0)
	Loop, 3
		LV_ModifyCol(1+A_Index, "AutoHdr")
	SelectItemByHwnd(ctrl)
	SetFormat, Integer, D
	SB_SetText(TV_GetCount() "/" LV_GetCount())
}



AddItem(cHwnd) {
	pId := 0, pHwnd := DllCall("GetParent", UInt,cHwnd, UInt)
	Loop, % LV_GetCount() 
	{
		LV_GetText(id,   A_Index, 1)
		LV_GetText(hwnd, A_Index, 2)
		if (hwnd == cHwnd)
			return false
		if (hwnd == pHwnd)
			pId := id
	}
	WinGetClass, name, ahk_id %cHwnd%
	id := TV_Add(name, pId, "Expand")
	LV_Add("", id, cHwnd, name)
	return id
}

FindControlDetails(treeId, ByRef hwnd, ByRef className, ByRef ctrlName) {
	Gui, ListView, LV1
	Loop, % LV_GetCount() 
	{
		LV_GetText(id,   A_Index, 1)
		LV_GetText(hwnd, A_Index, 2)
		if (hwnd == cHwnd)
			return false
		if (hwnd == pHwnd)
			pId := id
	}
}

SelectItemByHwnd(targetHwnd) {
	Loop, % LV_GetCount()
	{
		LV_GetText(id,   A_Index, 1)
		LV_GetText(hwnd, A_Index, 2)
		if (hwnd = targetHwnd) {
			row := A_Index, treeId := id
			break
		}
	}
	if (row)
		SelectTreeViewItemByRowId(row)
	if (treeId)
		SelectListViewItemByTreeId(treeId)
}

SelectListViewItemByTreeId(treeId) {
	Gui, ListView, LV1
	row := 0
	Loop, % LV_GetCount() 
	{
		LV_GetText(id,   A_Index, 1)
		if (id == treeId)
			row := A_Index
	}
	if (row)
		LV_Modify(row, "Select Focus Vis")
	ShowControlDetailsByRowId(row)
}

SelectTreeViewItemByRowId(row) {
	if (!row)
		return
	LV_GetText(treeId, row, 1)
	TV_Modify(treeId, "Select Vis Expand")
	GuiControl, Choose, Tb1,1
}

ShowControlDetailsByRowId(row) {
	Gui, ListView, LV1
	LV_GetText(hwnd,    row, 2)
	ShowControlDetails(hwnd)
}


ShowControlDetails(hwnd) {
	global SB_HORZ,SB_VERT,SB_CTRL,SBS_VERT,SB_Types,WS_HSCROLL,WS_VSCROLL
	Gui, ListView, LV2
	LV_Delete()
	IfWinNotExist, ahk_id %hwnd%
	{
		LV_Add("", "G[", "܂...")
		exit
	}
	SetFormat, Integer, D
	names = hwnd|class|left|top|right|bottom|width|height
	WinGetClass ,class, ahk_id %hwnd%
	WinGetPos,left,top,width,height ,ahk_id %hwnd%
	right:=left+width, bottom:=top+height
	Loop, PARSE, names, |
		LV_Add("", A_LoopField, %A_LoopField%)
	WinGet, style, Style, ahk_id %hwnd%
	LV_Add("", "Style", style)
	LV_Add("", "WS_HSCROLL", (style & WS_HSCROLL) ? "true" : "false")
	LV_Add("", "WS_VSCROLL", (style & WS_VSCROLL) ? "true" : "false")
	LV_Add("", "SBS_VERT", (style & SBS_VERT) ? "true" : "false")
	names = Min|Max|Page|Pos|TrackPos
	Loop, PARSE, SB_Types, |
	{
		dir:=A_LoopField
		ret := GetScrollInfoAll(hwnd, %dir%, nMin,nMax,nPage,nPos,nTrackPos)
		LV_Add("", dir, ret ? "true" : "false")
		Loop, PARSE, names, |
			LV_Add("", dir "." A_LoopField, n%A_LoopField%)
	}

	Loop,2
		LV_ModifyCol(A_Index, "AutoHdr")
	return true
}

ScrollTestInit(hwnd) {
	global SB_HORZ,SB_VERT,SB_CTRL,SBS_VERT,SB_Types
	GuiControl, Choose, Tb1, 2
	Gui, ListView, LV3
	LV_Delete()
	WinGetClass class, ahk_id %hwnd%
	WinGet, style, style, ahk_id %hwnd%
	GuiControl,,Edit1, %hwnd%
	GuiControl,,Edit2, %class%
	Loop, PARSE, SB_Types, |
	{
		ret := GetScrollInfoAll(hwnd, %A_LoopField%, min,max,page,pos,trakpos) && max>min
		Vertical := (%A_LoopField% == SB_VERT) || (%A_LoopField% == SB_CTRL && (style && SBS_VERT))
		LV_Add("", A_LoopField, ret, min,max,page,pos,trakpos, Vertical)
	}
	if (LV_GetCount() > 0) {
		GuiControl, Enable, LV3
		Loop,8
			LV_ModifyCol(A_Index, "AutoHdr")
	}
}

EnableScrollTest(row) {
	varNames = type|result|min|max|page|pos|trakpos|Vertical
	Loop, PARSE, varNames, |
		LV_GetText(%A_LoopField%, row, A_Index)
	if (!result) {
		cmd := 
	}
	cmd   := (result) ? "Enable" : "Disable"
	GuiControl, %cmd%, SbPos
	GuiControl,      , SbPos,    % pos
	GuiControl, %cmd%, SbUpDown
	GuiControl,+Range%min%-%max% , SbUpDown
	GuiControl, %cmd%, BtnTPosition
	GuiControl, %cmd%, BtnTTrack
	GuiControl, %cmd%, BtnUp
	GuiControl, %cmd%, BtnDn
}

DoScrollTest(sbCommand) {
	global SB_LINEUP,SB_LINEDOWN,SB_PAGEUP,SB_PAGEDOWN,SB_THUMBPOSITION,SB_ENDSCROLL,SB_THUMBTRACK
		, SB_HORZ, SB_VERT, SB_CTRL
	static WM_VSCROLL:=0x114,names:="SB_LINEUP,SB_LINEDOWN,SB_PAGEUP,SB_PAGEDOWN,SB_THUMBPOSITION,SB_THUMTRA"
	SetFormat, Integer, H
	Gui, ListView, LV3
	row := LV_GetNext(0, "F")
	LV_GetText(type,     row, 1)
	LV_GetText(vertical, row, 8)
	msg := vertical ? 0x115 : 0x114
	GuiControlGet, pos,, SbPos
	GuiControlGet, hwnd,, hwnd
	pos := RegExReplace(pos, ",", "", "", -1)
	ctrl := (%type% == SB_CTRL) ? DllCall("GetParent", "UInt",hwnd, "UInt") : hwnd
	sbar := (%type% == SB_CTRL) ? hwnd : 0
	wParam := sbCommand | pos<<16
	lParam := sbar
	PostMessage, msg, wParam,       lParam,, ahk_id %ctrl%
	PostMessage, msg, SB_ENDSCROLL, lParam,, ahk_id %ctrl%
	
	WinGetClass, sbClass, ahk_id %sbar%
	WinGetClass, targetClass, ahk_id %ctrl%
	Loop, PARSE,names, `,
		if (%A_LoopField% == sbCommand)
			sbCommandName := A_LoopField
	str =
(
pos   	: %pos%
------------------------------------------
msg   	: %msg%
wParam	: %wParam%	%sbCommandName%
lParam	: %lParam%	%sbClass%
ctrl  	: %ctrl%	%targetClass%
)
	GuiControl,,Log, %str%
	;Tooltip, msg = %msg% (%Vertical%) / %wParam% / %lParam% / %ctrl%(%pHwnd%) = %ErrorLevel%
	SetFormat,Integer, D
	ScrollTestInit(hwnd)
	EnableScrollTest(row)
	LV_Modify(row, "Focus Select")
}

MouseGetPos(ByRef x, ByRef y, ByRef hwnd, ByRef ctrl) {
	CoordMode, Mouse, Screen
	MouseGetPos, x, y, hwnd, ctrl, 3
	SendMessage,0x84,0,x|y<<16,,ahk_id %ctrl%
	If (ErrorLevel==0xFFFFFFFF)
		MouseGetPos,,,,ctrl,2
}

;
; type
;  SB_HORZ=0, SB_VERT=1, SB_CTRL=2
; see ttp://msdn.microsoft.com/ja-jp/library/cc364774.aspx
GetScrollInfoAll(hwnd, type, ByRef nMin="", ByRef nMax="", ByRef nPage="", ByRef nPos="", ByRef nTrackPos="") {
		VarSetCapacity(SCROLLINFO, 7*4, 0x00)
		NumPut(28,   SCROLLINFO, 0, "Int")
		NumPut(0x17, SCROLLINFO, 4, "Int") ; SIF_RANGE & SIF_PAGE & SIF_POS & SIF_TRACKPOS = 0x17
		nMin:="", nMax:="", nPage:="", nPos:="", nTrackPos:=""
		if (!DllCall("user32.dll\GetScrollInfo", UInt,hwnd, Int,type, Int,&SCROLLINFO, Bool))
			return false
		nMin := NumGet(SCROLLINFO, 8, "Int"), nMax := NumGet(SCROLLINFO, 12, "Int")
		, nPage := NumGet(SCROLLINFO, 16, "Int"), nPos := NumGet(SCROLLINFO, 20, "Int")
		, nTrackPos := NumGet(SCROLLINFO, 24, "Int")
		return true
}

